#version 330

in vec3 position;
in vec3 normal;
in vec2 texcoord;

// Task 6: add out variable for color of type vec3
out vec3 vNormal;
out vec3 vPosition;
out vec2 vTexCoord;

// Task 5: remove current normal, MVP and model matrices
//           add projection and view matrix uniforms
//           add array of model matrices with 100 items
// Task 6: add array materialColor of 100 colors (type vec4)
// Task 9: move the model and material color arrays to TeapotData uniform object
uniform mat4 MVP;
uniform mat3 N;
uniform mat4 model;

void main() {
    // Task 5: change the calculations to use the model matrix from array, with current gl_InstanceID as index
    // Task 6: pass the values (first 3 components) of the materialColor to vColor
    vNormal = normalize(N * normal);
    vPosition = vec3(model * vec4(position, 1.0));
    vTexCoord = texcoord;

    gl_Position = MVP * vec4(position, 1.0);
}
